if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem");
dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem", 
		[dijit._Widget, dijit._Templated], {
	spaceMeta : {},		
			
	templatePath : dojo.moduleUrl("com.ibm.mm.builder", "iwidget/spacemanager/widget/templates/SpaceItemTemplate.html"),			
	
	constructor : function() {
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
		this.pageUtil = com.ibm.mm.builder.utils.pageUtil;		
	},
			
	postMixInProperties : function() {
		var otherInfo;
		if (this.spaceMeta.owner !== null & this.spaceMeta.owner !== "") {
			otherInfo = dojo.string.substitute(this._bundle.I_SPACE_MANAGER_SPACE_INFO, [this.spaceMeta.owner, this.spaceMeta.pagesNum]);		
		} else {
			otherInfo = this._bundle.I_SPACE_MANAGER_SPACE_INFO_NO_OWNER;	
		}
				
		this.spaceInfo = {
				title: "",
				description: "",
				info: otherInfo,
				spaceId : this.spaceMeta.space.getID()
		};
		this.space = this.spaceMeta.space;
		this.spaceId = this.space.getID();
		this.iconUrl = this.spaceMeta.iconUrl;
		dojo.mixin(this, this._bundle);
	},	
	
	transformDescriptionForXss: function(spaceDescription){
		if (!spaceDescription) {
			spaceDescription = this.spaceMeta.description;
		}
		var textNode = dojo.doc.createTextNode(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(spaceDescription));
		var parentNode = this._descNode;
		dojo.empty(parentNode);
		parentNode.appendChild(textNode);
		
		var titleAttr = dojo.doc.createAttribute("title");
		titleAttr.nodeValue = spaceDescription;
		parentNode.setAttributeNode(titleAttr);
		
		//truncate
		var _self = this;
		setTimeout(function(){
			_self.truncateNodeText(parentNode, 420, "title", {fontSize:"12px"});
		},0);
	},
	
	transformTitleForXss: function(spaceTitle){	
		if (!spaceTitle) {
			spaceTitle = this.spaceMeta.title;
		}
		var textNode = dojo.doc.createTextNode(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(spaceTitle));
		var parentNode = this._titleNode;
		dojo.empty(parentNode);
		parentNode.appendChild(textNode);		

		var titleAttr = dojo.doc.createAttribute("title");
		titleAttr.nodeValue = spaceTitle;
		parentNode.setAttributeNode(titleAttr);

		//truncate
		var _self = this;
		setTimeout(function(){
			_self.truncateSpaceTitle();
		},0);
		//end truncate
		
		this._refreshHomeInfo();
	},
	
	truncateSpaceTitle: function(){
		var len = 100;
		var isHidden = this.space.isHidden();
		var isHomeSpace = this.spaceUtil.isHomeSpace(this.space.getID());
		if (isHidden && isHomeSpace){
			len = 100;
		} else {
			if (isHidden && !isHomeSpace){
				len = 150;
			} else {
				if (!isHidden && isHomeSpace){
					len = 350;
				} else {
					if (!isHidden && !isHomeSpace){
						len = 420;
					}
				}
			}
		}
		var truncateNode=dojo.query("._titleDiv span[class='title']",this.domNode)[0];
		this.truncateNodeText(truncateNode, len, "title", {fontSize:"14px"});		
	},
	
	_setHomeSpaceHint : function(){
		this._customInfo.innerHTML = this._bundle.I_SPACE_IS_HOME_SPACE;		
	},
	
	_removeHomeSpaceHint : function(){
		dojo.empty(this._customInfo);
	},
	
	truncateNodeText : function(/* DomNode */node, widthLimit, /* String */tipField, /*obj */fontStyle){
		var	textField = (node.tagName.toLowerCase() === "input") ? "value" : "innerHTML";
		if(!tipField){
			tipField = "title";
		}
		var str = dojo.string.trim(node[textField]);
		// if the title field is already set, then it should be truncated already, now we need to refresh the length of text in this node.
		if (dojo.hasAttr(node,tipField)){
			str = dojo.attr(node,tipField);
		}
		
		if(str.length === 0 ){return;}
		if (widthLimit > 0) {
			var shortStr = com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(str, node, widthLimit,fontStyle);
			if(shortStr.length <= str.length + 2 && !dojo.hasAttr(node,tipField)){
				dojo.attr(node,tipField,com.ibm.mm.builder.utils.htmlUtil.unEscapeString(str));
			}		
			node[textField] = (textField === "innerHTML" && (!dojo.hasAttr(node,"keepBlankSpace"))) ? com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(shortStr) : shortStr;
		}
	},
	
	postCreate : function() {
	
		this.transformTitleForXss();		
		this.transformDescriptionForXss();
		if (this.space) {	
			var spaceId = this.space.getID();
			var spaceItem = {"id":spaceId, "title": this.enablerUtil.getNodeTitle(this.space) || ""};
			
			this.connect(this._titleNode, "onclick", function() {
				dojo.publish(this._constants.Topic.Space.addToRecentSpaces, [spaceItem]);			
				dojo.publish(this._constants.Topic.Space["switch"], [spaceId]);
			});
			this.connect(this._titleNode, "onkeypress", function(evt) {
				if (evt.keyCode != dojo.keys.ENTER) {
					return;
				}
				dojo.publish(this._constants.Topic.Space.addToRecentSpaces, [spaceItem]);
				dojo.publish(this._constants.Topic.Space["switch"], [spaceId]);
				
				evt.preventDefault();
			});
			
			this._refreshIcon(this.iconUrl);
			
			this.refreshActionsMenu();			
			this._loadPages();
		}
	},
	
	destroy: function() {
		if (this._actionsWidget) {
			this._actionsWidget.destroy();
			delete this._actionsWidget;
			this._actionsWidget = null;
		}
			
		if (this._togglerWidget) {
			this._togglerWidget.destroy();
			delete this._togglerWidget;
			this._togglerWidget = null;
		}
			
		if (this._actionsNode) {
			delete this._actionsNode;
			this._actionsNode = null;
		};
		this.inherited(arguments);
	},
	
	//owner, pagenum, togglerWidget
	_loadPages : function() {
	
		if(this._constants.showPagesCount === "true"){
			var navMode = this.navigationUtil.getNavigationModel();
			var rootNodeId = this.space.getRootNavigation();		
			var rootPage = navMode.find(rootNodeId).start();
			this.hasPages = navMode.hasChildren(rootPage);
			
			var count = 0;			
			
			if (rootPage) {
				var iterator = navMode.getChildren(rootPage);
				count = iterator.size().start();
			}
			this._refreshOwnerAndPageNumInfo(count, this.spaceMeta.owner);
		}else{
			this._refreshOwnerAndPageNumInfo(-1, this.spaceMeta.owner);
		}

		this._refreshToggler();
		
	},
	
	refreshActionsMenu : function(){		
		var actionsNode = null;
		
		if(!this._actionsWidget){
			actionsNode = this._actionsNode;
		}else{
			actionsNode = dojo.create("div",{},this._actionsNode,"before");
			this._actionsWidget.destroyRecursive();
			delete this._actionsWidget;
		}		
		
		this._actionsWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu({spaceId : this.spaceId}, actionsNode);
		this._actionsNode = this._actionsWidget.domNode;

	},
	
	show : function(spaceId){
		this.refreshActionsMenu();
		this._refreshHiddenInfo(spaceId);
	},
	
	hide: function(spaceId){
		this.refreshActionsMenu();
		this._refreshHiddenInfo(spaceId);
	},
	
	addToFavorite : function(){
		this.spaceUtil.getSpaceModel(true);
		this.refreshActionsMenu();
	},
	
	removeFromFavorite : function(){
		this.spaceUtil.getSpaceModel(true);		
		
		var spacesListNode = this.domNode.parentNode;
		if(dojo.hasClass(spacesListNode, "favorite")){//remove space from fav list.
			if(spacesListNode.childNodes.length === 0){
				spacesListNode.innerHTML = this._bundle.I_SPACE_MANAGER_NO_SPACES_FOUND;
			}
			this.destroyRecursive();			
			return;
		}
		
		this.refreshActionsMenu();
	},
	
	makeHome : function(){
		this._setHomeSpaceHint();
		this.refreshActionsMenu();
	},
	
	unMakeHome : function(){
		this._removeHomeSpaceHint();
		this.refreshActionsMenu();		
	},
	
	remove : function(){
		var spacesListNode = this.domNode.parentNode;
		if(spacesListNode && spacesListNode.childNodes.length === 1){//current space item is the last space dijit.
			spacesListNode.innerHTML = this._bundle.I_SPACE_MANAGER_NO_SPACES_FOUND;
		}			
		this.destroyRecursive();		
	},
	
	refresh : function(){
		this.space = this.spaceUtil.getSpaceNode(this.spaceId);
		this._refreshTitle();
		this._refreshDescription();
		this._refreshIcon();
		this._refreshOwnerAndPageNumInfo();
		this._refreshHomeInfo();
		this._refreshHiddenInfo();
		this._refreshToggler();
		
	},
	
	_refreshTitle: function(){
		
		var spaceTitle = this.enablerUtil.getNodeTitle(this.space) || this._bundle.I_SPACE_MANAGER_NO_TITLE;
		this.transformTitleForXss(spaceTitle);
	},
	
	_refreshDescription: function(){
		var spaceDescription = this.enablerUtil.getNodeDescription(this.space) || this._bundle.I_SPACE_MANAGER_NO_DESCRIPTION;
		this.transformDescriptionForXss(spaceDescription);
	}, 
	
	_refreshIcon: function(iconUrl){
		if(!iconUrl){
			this.iconUrl = this.spaceUtil.getSpaceIconURL(this.space);
		}
		if (this.iconUrl) {
			dojo.empty(this._iconNode);
			dojo.addClass(this._iconNode, "space_icon");
			var img = dojo.doc.createElement("img");
			dojo.attr(img, {
				"alt" : "",
				"src" : this.iconUrl
			});
			this._iconNode.appendChild(img);
		}
		
	},
	
	_refreshOwnerAndPageNumInfo : function(pageNum, spaceOwner){
		this.spaceManagerUtil.model.getSpaceACModel(this.space).getOwnerDeferred().setFinishedCallback(dojo.hitch(this, function(result, status){
		
		if (!spaceOwner && status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK) {
					spaceOwner = result.getDisplayName();
				}
					
				if (spaceOwner !== null & spaceOwner !== "") {
					var info = "";
					if (pageNum > -1) {
						info = dojo.string.substitute(this._bundle.I_SPACE_MANAGER_SPACE_INFO, [spaceOwner, pageNum]);
					}
					else {
						info = dojo.string.substitute(this._bundle.I_SPACE_MANAGER_SPACE_INFO, [spaceOwner, 0]);
						info = info.substring(0, info.indexOf("|"));
					}
					this._infoNode.innerHTML = info;
				}
				else {
					this._infoNode.innerHTML = this._bundle.I_SPACE_MANAGER_SPACE_INFO_NO_OWNER;
				}
		})).start(false);
	},
	
	_refreshHomeInfo : function(){
		if(this.spaceUtil.isHomeSpace(this.space.getID())){								
			this._setHomeSpaceHint();
		}else{
			this._removeHomeSpaceHint();
		}
	},
	
	_refreshHiddenInfo : function(spaceId){
		var space = null;
		if(spaceId) {
			space = this.spaceUtil.getSpaceNode(spaceId);
		} else {
			space = this.space;
		}
		if(space.isHidden()){
			dojo.addClass(this.domNode, "hidden_space");
			this._refreshTitle();
		}else{
			dojo.removeClass(this.domNode, "hidden_space");
			this._refreshTitle();
		}		
	},
	
	_refreshToggler : function(){
		
		var togglerNode = null;
		
		if(!this._togglerWidget){
			togglerNode = this._togglerNode;
			this._pagesNode = dojo.query(".pages", this.domNode)[0];
			//var navMode = this.navigationUtil.getNavigationModel();
			var rootNodeId = this.space.getRootNavigation();		
			//var rootPage = navMode.find(rootNodeId).start();
			this._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : this._pagesNode, "parentPageId": rootNodeId, "space": this.space, "level": 0}, togglerNode);
			this._togglerNode = this._togglerWidget.domNode;
		}	
		
	},
	
	createSubPage: function(page){
		var pagesNode = dojo.query(".pages", this.domNode)[0];
		var newPageNode = dojo.create("div", {}, pagesNode);	//JSLINT-IGNORE
		var pageOwner = "";										//JSLINT-IGNORE
		if (this._constants.showPageOwner === "true") {
			pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.space, page);
		}
		var _self = this;
		var pageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
			pageMeta: {
				title: _self.enablerUtil.getNodeTitle(page) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
				description: _self.enablerUtil.getNodeDescription(page) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
				owner: pageOwner,
				level: 1,
				space: this.space,
				page: page,
				pageId: page.getID()
			}
		}, newPageNode);
		
		if(page.isHidden()){
			dojo.addClass(pageItem.domNode, "hidden_page");
			dojo.addClass(pageItem._flagNode, "hidden_flag");
		}
		
		var parentPage = this.pageUtil.getParentPageNode(page.getID());
		if(!(this._togglerWidget)){
			this._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : pagesNode, "parentPage": parentPage, "space": this.space, "level": 0}, dojo.query(".toggler", this.domNode)[0]);
		}
		var navMode = this.navigationUtil.getNavigationModel(); 	//JSLINT-IGNORE
		var rootNodeId = this.space.getRootNavigation();
		// tactical solution to get updated root node; a more general
		// invalidation framework will be in place later on
		navMode.invalidate(rootNodeId);
		
		if(this._constants.showPagesCount === "true"){
			var count = 0;
			var rootPage = navMode.find(rootNodeId).start();
			if (rootPage) {
				var iterator = navMode.getChildren(rootPage);
				count = iterator.size().start();
			}
			var info = dojo.string.substitute(this._bundle.I_SPACE_MANAGER_SPACE_INFO, [com.ibm.mm.builder.utils.acModelUtil.getSpaceOwner(this.spaceId).getDisplayName(), count]);
			dojo.query(".info", this.domNode)[0].innerHTML = info;
		}
	}
	
});

}
