if(!dojo._hasResource["com.ibm.mm.builder.utils.layoutUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.layoutUtil"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.layoutUtil");

dojo.require("dojo.number");
dojo.require("dojo.string");

dojo.require("dijit.form.Slider");

dojo.require("com.ibm.mm.builder.widget.CustomDialog");

com.ibm.mm.builder.utils.layoutUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.layoutUtil");

com.ibm.mm.builder.utils.layoutUtil.getPageSize=function(){
	var windowHeight;
	if (self.innerHeight) { 
		// all except Explorer
		windowHeight = self.innerHeight;
	} else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
		windowHeight = document.documentElement.clientHeight;
	} else if (document.body) { 
		// other Explorers
		windowHeight = document.body.clientHeight;
	}
	return windowHeight;	
};

com.ibm.mm.builder.utils.layoutUtil.getPageContent=function(pid){
	if(!pid){
        if (!com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode()) {
            // User has no pages in navigation
    		var empty_content = 
    			"<div class='empty_div'>"+
    				"<div class='empty_outer_div'>" +
    					"<div class='empty_inner_div'>" +
    					com.ibm.mm.builder.utils.htmlUtil.formatMessage(com.ibm.mm.builder.coreWidgetsStrings.W_NO_PAGE_TO_SHOW) +
    					"</div>" +
    				"</div>"+
    			"</div>";
            return {"content":empty_content};
        }
		return;
	}
	try{
		if (com.ibm.mm.builder.utils.pageUtil.isEmptyPage(com.ibm.mm.builder.utils.pageUtil.getPageNode(pid))){
			return null;
		}
		var pageContent = {};
		var layoutModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel().getLayoutModel(pid);
		if(!layoutModel){ return null; }
		var lmRoot = layoutModel.getRoot().start();
	    if (lmRoot){
	    	pageContent.content = lmRoot.getFragment();
			var pageAttributes = {};
			var metadataNames = lmRoot.getMetaDataNames();
			dojo.forEach(metadataNames, function(metadataName){
				pageAttributes[metadataName] = lmRoot.getMetaData(metadataName);
			});
			
			pageContent.pageAttributes  = pageAttributes;
	        return pageContent;
	    } else {
	        return null;
	    }
	}catch(e){
		com.ibm.mm.builder.utils.layoutUtil.LOGGER.severe(
			"getPageContent",
			dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_MAIN_INVALID_ID_2,[pid,e.message])
		);
	}    
};

/**
 * transformBgIamge is change a pagebackgroundiamge's url into a legal one in columnformlayout.
 * @param {String} pageBgIamgeValue
 */
com.ibm.mm.builder.utils.layoutUtil.transformBgIamge = function(pageBgIamgeValue){
	// TODO: remove the hardcoded number
	if(pageBgIamgeValue.search(/url/i) !== 0){
		pageBgIamgeValue = "url" + pageBgIamgeValue;
	}
	if(pageBgIamgeValue.indexOf("(") != 3){
		pageBgIamgeValue = pageBgIamgeValue.substring(0,3) + "(" +  pageBgIamgeValue.substring(3) + ")";
	}
	if(pageBgIamgeValue.search(/http/i) != 4){
		if(pageBgIamgeValue.substring(4,5) != "/"){
			pageBgIamgeValue = pageBgIamgeValue.substring(0,4) + "http://" + pageBgIamgeValue.substring(4) + "";
		}
	}
	return pageBgIamgeValue;
};

com.ibm.mm.builder.utils.layoutUtil.setBorderSelect = function(borderSelect) {
	var index = 0;
	borderSelect.options[index++].innerHTML = com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_NONE;
	var widths = [1,2,3];
	var styles = [com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_SOLID,
				  com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_DOTTED,
				  com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_DOUBLE];
	for(var i=0; i<styles.length; i++) {
		for(var j=0; j<widths.length; j++) {
            borderSelect.options[index++].innerHTML = widths[j] + com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PAGE_UNIT + " " + styles[i];
		}
	}
};

com.ibm.mm.builder.utils.layoutUtil.createSlider=function(iWID,targetDivId,valueDivId,startValue,displayArtifact,maximValue,increment,graphicDivId){
	var sliderDiv = dojo.byId(iWID + targetDivId);
	dojo.byId(iWID + valueDivId).innerHTML = startValue + displayArtifact;
	var slider = dijit.byId(iWID + targetDivId);
	if (slider){
		slider.destroy();
	}
	var sliderProp = {};
	sliderProp.id = iWID + targetDivId;
	sliderProp.value = startValue;
	sliderProp.pageIncrement = increment;
	sliderProp.maximum = maximValue;
	sliderProp.showButtons = false;
	sliderProp.style = "width:120px;height:20px;";
	slider = new dijit.form.HorizontalSlider(sliderProp,sliderDiv);
	dojo.connect(slider,"onChange",null,function(newvalue){
		var transformed = dojo.number.format(arguments[0],{places:0,pattern:'##.'});
		dojo.byId(iWID + valueDivId).innerHTML = transformed + displayArtifact;
		if(graphicDivId){
			dojo.byId(iWID + graphicDivId).style.width = transformed + "px";
		}
	});
};

com.ibm.mm.builder.utils.layoutUtil.getPageBorderSelectIndex=function(prop){
	var index = 0;
	switch(prop){
		case "none":
			index = 0;
			break;
		case "1px solid":
			index = 1;
			break;
		case "2px solid":
			index = 2;
			break;
		case "3px solid":
			index = 3;
			break;				
		case "1px dotted":
			index = 4;
			break;
		case "2px dotted":
			index = 5;
			break;
		case "3px dotted":
			index = 6;
			break;					
		case "3px double":
			index = 7;
			break;	
		case "6px double":
			index = 8;
			break;
		case "9px double":
			index = 9;
			break;																								
	}
	return index;
};

com.ibm.mm.builder.utils.layoutUtil.getImagePropSelectIndex=function(prop){
	var index = 0;
	switch(prop){
		case "RepeatX":
			index = 0;
			break;
		case "RepeatY":
			index = 1;
			break;
		case "Repeat":
			index = 2;
			break;
		case "Center":
			index = 3;
			break;												
	}
	return index;
};

com.ibm.mm.builder.utils.layoutUtil.stretchHeight = function(layoutId){
	var root = dojo.byId(layoutId);
	var widgetcontents = dojo.query("." + com.ibm.mm.builder.constant.iWidgetContent,root);
	var len = widgetcontents.length;
	if (len===0){
		widgetcontents = dojo.query("." + com.ibm.mm.builder.constant.iwWidgetContent,root);
		len = widgetcontents.length;
	}
	for (var i=0;i<len;i++){
		if (widgetcontents[i].parentNode == root){
			widgetcontents[i].style.height = "100%";
			break;
		}
	}
};
	
com.ibm.mm.builder.utils.layoutUtil.addTip = function(msg,node,maxlen,field) {
	if (!field) {
		field = "innerHTML";
	}
	if(msg.length > maxlen) {
		node[field] = msg.substr(0,maxlen) + "...";
		node.setAttribute("title",msg);
	} else {
		node[field] = msg;
	}
};

com.ibm.mm.builder.utils.layoutUtil.removeAllChildren = function(fNode){
	var children = null;
	if (dojo.isIE){
		children = fNode.children;
	}else{
		children = fNode.childNodes;
	}
	var len = children.length;
	if (len!==0){
		for (var i=0;i<len;i++){
			dojo.destroy(children[i]);
		}
	}
};

com.ibm.mm.builder.utils.layoutUtil.widgetInLayout = function(widgetId,layoutId){
	if (widgetId == layoutId){return false;}
	var widget = dojo.byId(widgetId);
	if (widget){
		var node = widget;
		while (node.tagName != "BODY"){
			if (node.id == layoutId) {
				return true;
			}
			node = node.parentNode;
		}
	}else{
		return false;
	}
	return false;
};	

com.ibm.mm.builder.utils.layoutUtil.publishWidgetSize = function(widgetId){
	var loadedHandler = null;
	var publishWidgetSize = function(){
		var widgetBox = dojo.contentBox(widgetId + "_content");
		var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
		var payload = {"newWidth": widgetBox.w,"newHeight": widgetBox.h};
		eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widgetId,payload);	
		if (loadedHandler) {
			eventService.unsubscribeEvent(loadedHandler, null);
		}
	};
	var wm = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetId);
	if (wm && wm.loaded) {
		publishWidgetSize();
	} else {
		var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
		loadedHandler = eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + widgetId, null, publishWidgetSize);
	}	
};

com.ibm.mm.builder.utils.layoutUtil.resizeWidget = function(widgetId, height, width){
    if (width) {
		com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeResized(widgetId, width);
	}
    
    var widgetSkinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
    var skinBox = dojo.contentBox(widgetSkinNode);			
	
	if (width && builderConfig.isBidi) {
		var origLeft = parseInt(widgetSkinNode.style.left,10);
		var dx = skinBox.w - width;
		var newLeft = origLeft + dx;
		dojo._setBox(widgetSkinNode, newLeft);
	}		
	
    if (width) {
		skinBox.w = width;
	}
    skinBox.h = height;
    dojo.contentBox(widgetSkinNode, skinBox);
    
    var widgetContentNode = dojo.byId(widgetId + com.ibm.mm.builder.constant.widgetContent);
    var widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(dojo.byId(widgetId + com.ibm.mm.builder.constant.widgetBody),"paddingTop");
	widgetBodyPadTop = widgetBodyPadTop ? parseInt(widgetBodyPadTop,10) : 0;
	
    var hack_widgetContentBox = dojo.contentBox(widgetContentNode);
	
    dojo.marginBox(widgetContentNode, {
        l: 0,
        t: 0,
        w: width ? width : -1,
        h: height - widgetBodyPadTop
    });
    
    var widgetContentBox = dojo.contentBox(widgetContentNode);
	
	//this is a work-around to fix an issue in safari rtl where content box seems to always
	//decrease in width regardless whether margin box is increasing or decreasing
	if(dojo.isSafari && builderConfig.isBidi){
		dojo.contentBox(widgetContentNode,{w:(widgetContentBox.w + 2*(hack_widgetContentBox.w - widgetContentBox.w))});
	}
	var newWidth = width ? widgetContentBox.w : -1;
	if (!width) {
		dojo.style(widgetSkinNode, "width", "auto");
	}//9632
	var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
    eventService.broadcastEvent("com.ibm.mashups.builder.widgetResized", {
        widgetId: widgetId,
        width: newWidth,
        height: widgetContentBox.h
    });
	
	var payload = {"newWidth": newWidth,"newHeight": widgetContentBox.h};
	eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + widgetId, payload);
};

com.ibm.mm.builder.utils.layoutUtil.refreshLayoutData = function(widgetId){
	if (com.ibm.mm.builder.columnLayoutBean){
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil.refreshLayoutData(widgetId);
	}
};

}
