if(!dojo._hasResource["com.ibm.mm.builder.widget.ColumnWidthResizer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ColumnWidthResizer"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.ColumnWidthResizer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");

dojo.declare(
	"com.ibm.mm.builder.widget.ColumnWidthResizer",
	[dijit._Widget, dijit._Templated, dijit._Container],
{
	wid: '',
	
	visible: false,
	
	leftColumnId: '',
	
	rightColumnId: '',
	
	zIndex:'',
	
	columnContainer:'',
	
	colWidthReserved: 60,
	
	iconImageUrl: builderConfig.builderPath + "/images/dragHandle.png",
	iconImagHoverUrl:builderConfig.builderPath + "/images/dragHandle_hover.png",
	
	templateString: "<div id=\"${wid}\" class=\"columnWidthResizer\">"+
						"<img dojoAttachPoint='dragHandler' role=\"button\" wairole=\"button\" tabindex='0'  title='' id='${wid}_img' style='position:relative;visibility:hidden;'/>"+
					"</div>",
	step:1,
	connects:[],
	// defaultTimeout: Number
	//	  number of milliseconds before a held key or button becomes typematic
	defaultTimeout: 200,

	// timeoutChangeRate: Number
	//	  fraction of time used to change the typematic timer between events
	//	  1.0 means that each typematic event fires at defaultTimeout intervals
	//	  < 1.0 means that each typematic event fires at an increasing faster rate
	timeoutChangeRate: 0.9,
	
	postCreate: function(){
		this.widgetId = this.wid;
		var leftColumn = this.leftColumnId.substring(this.leftColumnId.length-7,this.leftColumnId.length);
		var rightColumn = this.rightColumnId.substring(this.rightColumnId.length-7,this.rightColumnId.length);
		
		dojo.attr(this.dragHandler,'alt',com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_RESIZER);
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_DRAG_HANDLER,[leftColumn,rightColumn]);
		//var title = "Drag or use left or right arrow keys to resize " + leftColumn + " or " + rightColumn;
		dojo.attr(this.dragHandler,'title',title);
		dojo.attr(this.dragHandler,'aria-label',title);
		
		this.overHandler = dojo.connect(this.domNode, "onmouseover", this, "mouseOverAction");
		this.focusHanlder = dojo.connect(this.dragHandler, "onfocus", this, "focusAction");
		this.blurHanlder = dojo.connect(this.dragHandler, "onblur", this, "mouseOutAction");
		this.outHandler = dojo.connect(this.domNode, "onmouseout", this, "mouseOutAction");
		this.moveHandler = dojo.connect(this.domNode, "onmousemove", this, "mouseMoveAction");
		
		this.beginSizingHandler = dojo.connect(this.domNode, "onmousedown", this, "_beginSizing");
		
		this.connects.push(dijit.typematic.addListener(null, this.dragHandler, {charOrCode:dojo.keys.LEFT_ARROW,ctrlKey:false,altKey:false,shiftKey:false}, this, "_typematicCallback", this.timeoutChangeRate, this.defaultTimeout));
		this.connects.push(dijit.typematic.addListener(null, this.dragHandler, {charOrCode:dojo.keys.RIGHT_ARROW,ctrlKey:false,altKey:false,shiftKey:false}, this, "_typematicCallback", this.timeoutChangeRate, this.defaultTimeout));
	
//		this.keySizingHanlder = dojo.connect(this.dragHandler, "onkeypress",this, "_beginKeySizing");
		//set the zindex of drag hanlder as the max
		this.dragHandler.style.zIndex = this.zIndex + 1 + "";
		this.dragHandler.src = this.iconImageUrl;
		var pageAttrJSONObject = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();	 
		var betweenColWidth = pageAttrJSONObject.widthBetweenColumn;
		this.dragHandler.style.left = betweenColWidth/2 -5 + "px";
		if(this.visible){
			this.toEditMode();
		}else{
			this.toViewMode();
		}
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.widget.ColumnWidthResizer");
	},
	
	toViewMode:function(){
		var divObj = dojo.byId(this.wid);
		if (divObj){
			divObj.style.cursor = "auto";
			this.dragHandler.style.visibility = "hidden";
		}
		if (divObj){
			dojo.disconnect(this.overHandler);
			dojo.disconnect(this.focusHanlder);
			dojo.disconnect(this.outHandler);
			dojo.disconnect(this.blurHanlder);
			dojo.disconnect(this.moveHandler);
			dojo.disconnect(this.beginSizingHandler);
//			dojo.disconnect(this.keySizingHanlder);	
			this._removeAllHandler();
			this.connects = [];	
		}
	},
	
	toEditMode:function(){
		var divObj = dojo.byId(this.wid);
		if (divObj){
			divObj.style.cursor = "e-resize";
		}
		if (divObj){
			var imgObj = dojo.byId(this.wid+"_img");
			imgObj.style.visibility = "visible";
			this.overHandler = this.overHandler || dojo.connect(this.domNode, "onmouseover", this, "mouseOverAction");
			this.focusHanlder = this.focusHanlder || dojo.connect(this.dragHandler, "onfocus", this, "focusAction");
			this.outHandler = this.outHandler ||  dojo.connect(this.domNode, "onmouseout", this, "mouseOutAction");
			this.blurHanlder = this.blurHanlder || dojo.connect(this.dragHandler, "onblur", this, "mouseOutAction");
			this.moveHandler = this.moveHandler || dojo.connect(this.domNode, "onmousemove", this, "mouseMoveAction");
			this.beginSizingHandler = this.beginSizingHandler || dojo.connect(this.domNode, "onmousedown", this, "_beginSizing");	
	
			this.connects.push(dijit.typematic.addListener(null, this.dragHandler, {charOrCode:dojo.keys.LEFT_ARROW,ctrlKey:false,altKey:false,shiftKey:false}, this, "_typematicCallback", this.timeoutChangeRate, this.defaultTimeout));
			this.connects.push(dijit.typematic.addListener(null, this.dragHandler, {charOrCode:dojo.keys.RIGHT_ARROW,ctrlKey:false,altKey:false,shiftKey:false}, this, "_typematicCallback", this.timeoutChangeRate, this.defaultTimeout));
		}
	},
	
	mouseMoveAction: function(e){
		this.mouseAction(e);
	},
	
	mouseAction:function(e,timer){
		this.cBox = this.cBox  ||  dojo.marginBox(dojo.byId(this.columnLayoutID));
		var loc = dojo.coords(this.domNode);
		var imgObj = dojo.byId(this.wid+"_img");
		var pageY = e.pageY;
		var boxT = this.cBox.t + ((dojo.isIE < 8) ? 103 :0);
		var timerHandler = window.setTimeout(function() {			
			var posY = pageY - boxT;
			posY = posY<0 ? 0 : posY;
			posY = posY > 45 ? (posY - 45) : 0;
			posY = posY>loc.h-52 ? loc.h-52 : posY;
			imgObj.style.top = posY + "px";
			imgObj.style.visibility = "visible";
		},10);
		if(timer){ timer = timerHandler;}
	},
	
	mouseOverAction:function(e){
		this.dragHandler.src = this.iconImagHoverUrl;
		this.mouseAction(e,this.showIconTimer);
	},
	
	focusAction:function(e){		
		this.dragHandler.src = this.iconImagHoverUrl;	
	},
	
	mouseOutAction:function(e){
		this.dragHandler.src = this.iconImageUrl;
		var imageId = this.wid+"_img";	
		var imgObj = dojo.byId(imageId);	
		this.showIconTimer = window.setTimeout(function() {		
			imgObj.style.top = "0px";
		},10);		
	},	

	_beginSizing: function(/*Event*/ e){
		// if the column is resizing, return
		if (this._isSizing){ 
			return false; 
		}
		this._isSizing = true;
		
		this.startX  = e.clientX;
		
		this._getStartStatus();		
		this.changesizingHandler = dojo.connect(document, "onmousemove", this, "_changeSizing");
		this.endsizingHandler = dojo.connect(document, "onmouseup", this, "_endSizing");

		e.preventDefault();
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
	},
	
	_getStartStatus:function(){
		var leftColumn = dojo.byId(this.leftColumnId);
		//var leftWidthValue = parseInt(leftColumn.style.width);
		var leftWidthValue = Math.ceil(dojo.style(leftColumn, "width"));
		var rightColumn = dojo.byId(this.rightColumnId);
		//var rightWidthValue = parseInt(rightColumn.style.width);
		var rightWidthValue = Math.ceil(dojo.style(rightColumn, "width"));
		this.leftColumnStartWidth = leftWidthValue;
		this.rightColumnStartWidth = rightWidthValue;
		var pageAttrJson = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();
		this.widgetMargin = 2*pageAttrJson.widgetLeftRightMargin;
	},
	
	_typematicCallback: function(/*Number*/ count, /*DOMNode*/ node, /*Event*/ evt){
		if(node == this.dragHandler){
			k=dojo.keys;
			var key = evt.charOrCode; 
			if((key == k.RIGHT_ARROW) || (key == k.LEFT_ARROW)){
				this._beginKeySizing(key);
			}
			
		}
	},
	
	_beginKeySizing:function(/*Event*/key){
		this._getStartStatus();		
		var leftActualWidth,rightActualWidth;
		if(key === dojo.keys.RIGHT_ARROW){
			leftActualWidth = this.leftColumnStartWidth + this.step;
			rightActualWidth = this.rightColumnStartWidth - this.step;	
			if (leftActualWidth < (this.colWidthReserved + this.widgetMargin) || rightActualWidth < (this.colWidthReserved + this.widgetMargin)) {
				return;
			}		
		}else if(key === dojo.keys.LEFT_ARROW){
			leftActualWidth = this.leftColumnStartWidth - this.step;
			rightActualWidth = this.rightColumnStartWidth + this.step;
			if (leftActualWidth < (this.colWidthReserved + this.widgetMargin) || rightActualWidth < (this.colWidthReserved + this.widgetMargin)) {
				return;
			}			
		}
		if (leftActualWidth) {
			this._setColumnWidth(this.leftColumnId, this.leftColumnIndex, leftActualWidth);
		}
		
		if (rightActualWidth) {
			this._setColumnWidth(this.rightColumnId, this.rightColumnIndex, rightActualWidth);
		}		
	},

	_changeSizing: function(/*Event*/ e){
		var containerWidth = dojo._getContentBox(dojo.byId(this.columnContainer)).w;
		var x0 = dojo._abs(dojo.byId(this.columnContainer)).x;
		var x1 = x0 + containerWidth;
		try{
			if(!e.clientX){
				this.LOGGER.log(com.ibm.mashups.enabler.logging.LogLevel.WARNING,"clientX is not available");
				return; 
			}else{
				if ((e.clientX> x1 - 50) || (e.clientX - 50 < x0)){
					return;
				}
			}
		}catch(ex){
			this.LOGGER.severe("_changeSizing",dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_COLUMN_WITH_RESIZER_CHANGE_SIZE_1,[ex.message]));
			return;
		}
		var dx;
		var leftActualWidth,rightActualWidth;
		if (this.startX > e.clientX){
			// this is from right to left
			dx = this.startX - e.clientX;
			leftActualWidth = this.leftColumnStartWidth - dx;
			rightActualWidth = this.rightColumnStartWidth + dx;
			if (leftActualWidth < (this.colWidthReserved + this.widgetMargin) || rightActualWidth < (this.colWidthReserved + this.widgetMargin)) {
				return;
			}
		}else{
			// this is from left to right
			dx = e.clientX - this.startX;
			leftActualWidth = this.leftColumnStartWidth + dx;
			rightActualWidth = this.rightColumnStartWidth - dx;	
			if (leftActualWidth < (this.colWidthReserved + this.widgetMargin) || rightActualWidth < (this.colWidthReserved + this.widgetMargin)) {
				return;
			}
		}
		
		this._setColumnWidth(this.leftColumnId, this.leftColumnIndex, leftActualWidth);
		
		this._setColumnWidth(this.rightColumnId, this.rightColumnIndex, rightActualWidth);		
		
		e.preventDefault();
	},

	_endSizing: function(/*Event*/ e){
		dojo.disconnect(this.changesizingHandler);
		dojo.disconnect(this.endsizingHandler);
		this._isSizing = false;
		
		var widgetResized = function(widget){
			var widgetBox = dojo.contentBox(widget.id + "_content");
			var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
			var payload = {"newWidth": widgetBox.w,"newHeight": widgetBox.h};
			eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widget.id,payload);
		}; 
		dojo.query(".iWidgetSkin[skin]", dojo.byId(this.leftColumnId)).forEach(widgetResized);
		dojo.query(".iWidgetSkin[skin]", dojo.byId(this.rightColumnId)).forEach(widgetResized);
		dojo.forEach([dojo.byId(this.leftColumnId),dojo.byId(this.rightColumnId)],function(column){
			var widgets = column.childNodes;
			for(var i=0,len = widgets.length; i<len;i++ ){
				var widget = widgets[i];
				if(widget && widget.id && widget.id.indexOf("mm_ibm_skin_ns_") != -1){
					com.ibm.mm.builder.utils.skinUtil.updateTitleAndIcon(widget.id.replace(/mm_ibm_skin_/,""));
				}
			}
		});
	},
	
	_setColumnWidth : function(id, index, width) {
		var column = dojo.byId(id);
		dojo.style(column, "width", width + "px");
		this.configHelper._setRelativePercentageForColumn(index, width);
	},
	
	_removeAllHandler: function(){
		this.overHandler = null;
		this.focusHanlder = null;
		this.outHandler = null;
		this.blurHanlder = null;
		this.moveHandler = null;
		this.beginSizingHandler = null;
	}
	
});

}
