if(!dojo._hasResource["com.ibm.mm.builder.widget.CustomDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.CustomDialog"] = true;
dojo.provide("com.ibm.mm.builder.widget.CustomDialog");

dojo.require("dojo.fx");
dojo.require("dijit.Dialog");

dojo.require("com.ibm.mm.builder.utils.htmlUtil");
dojo.require("com.ibm.mm.builder.widget.CustomDialogResizer");
dojo.require("com.ibm.mm.builder.widget.CustomDialogMoveable");

dojo.declare("com.ibm.mm.builder.widget.CustomDialog", [dijit.Dialog], {

    templateString: 
		"<div dojoAttachPoint='dialogNode' waiRole='dialog' title='' aria-label='dialog'>" +
		    "<div dojoAttachPoint='dialogDivsNode' class='customDialogDiv lotusDialog' role='region' aria-label='dialog'>" +
			    "<div id='${id}_titleBar' dojoAttachPoint='titleBar' class='dialog_titlebar' waiRole='dialog' aria-label='dialog'>" +
					"<a id='${id}_closeIcon' title='${closeIconTitle}' class='dialog_titlebar_close_wrapper lotusBtnImg' dojoAttachPoint='closeButtonNode'" +
						"href='javascript:;' aria-label='${closeIconTitle}' dojoAttachEvent='onclick:trueHide,onkeypress:hideWithKey'>" +
						"<img alt='${closeIconTitle}' title='${closeIconTitle}' class='dialog_titlebar_close' src='" + builderConfig.builderPath + "/images/oneui/blank.gif'/>" +
						"<span class='lotusAltText'>X</span>" +
					"</a>" +
			    	"<div dojoAttachPoint='titleNode' class='dialog_titlebar_title'></div>" +
		    	"</div>" +
			    "<div dojoAttachPoint='containerNode' class='dialog_container'></div>" +
			    "<span dojoAttachPoint='tabEnd' ></span>" +
			    "<div dojoAttachPoint='leftBar' class='dialog_leftsidebar'></div>" +
			    "<div dojoAttachPoint='rightBar' class='dialog_rightsidebar'></div>" +
			    "<div dojoAttachPoint='endBar' class='dialog_endbar'></div>" +
			    "<div dojoAttachPoint='leftResizeHandler' class='dialog_leftResize_handler'></div>" +
			    "<div dojoAttachPoint='rightResizeHandler' class='dialog_rightResize_handler'></div>" +
		    "</div>" +
    	"</div>",
    baseClass: "custom_dialog",
    
    sharedWidget: false, //whether this dialog widget should alive when page change
    
	belongId: null,
    
    nodeWidth: null,
    
    nodeHeight: null,
    
    title: null,
    
    titleHeight: 28,
    
    titleBarHeight: "0px",
    
    endBarHeight: "0px",
    
    bottomHeight: 14,
    
    topBarBackground: null,
    
    topBarOpacity: null,
    
    bottomBarBackground: null,
    
    bottomBarOpacity: null,
    
    bottomBarTip: null,
    
    bottomBarTipColor: "white",
    
    leftBarWidth: "0px",
    
    rightBarWidth: "0px",
    
    displayCloseButton: true,
    
    containerNodePadding: null,
    
    containerBackgroundColor: null,
    
    containerOpacity: null,
	
	dialogOpacity: null,
    
    hasLeftBottomResizer: false,
    
    hasRightBottomResizer: true,
    
    modelDialog: true,
    
    needUnderLay: true,
    
    initLeftPosition: null,
    
    initTopPosition: null,
    
    alwaysCenter: true,
    
    subDialogs: null,
    
    roundCorner: false,
    
    dialogStack: [],
    
    innerConnects: [],
    
    closeCallback: null, 	// a callback to set when you need to do something when the dialog is hided
    
	displayCallback: null,  // a callback to set when you need to do something after the dialog is displayed
    
    dynaInitialized: false, // used when user doens't specify the node's width
    						// After calculate the outer container's width, will be set to true
    
    closeIconTitle: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL,
    
    //isEmbedPageBidi: false, // 8143: embedPage will set to true when creating a bidi preview dialog 
    // 9637: removed rtl version of custom_dialog_nomodel so removed param isEmbedPageBidi
    
	scrollEnabled: false,
	
    postCreate: function(){
        this.inherited(arguments);
        this.domNode.className = "custom_dialog";
        this.subDialogs = [];
		//this.setTitle();//postpone until show to allow width to be set
		if (this.scrollEnabled) {
			dojo.style(this.containerNode, "overflow", "scroll");
		}
        
		dojo.subscribe("/enabler/pageChanged", this, "destroyOnPageChange");
    },
    
    setTitle: function(title){
		this.title = title || this.title;
		if (this.title && this.titleNode && this.title != this.titleNode.title) {
			com.ibm.mm.builder.utils.htmlUtil.setNodeTitle(this.title, this.titleNode);
			
		}
		dojo.attr(this.dialogNode, "title", this.title);
		dojo.attr(this.titleBar, "title", this.title);
	},
    
    // Search for if the page contains an applet
    containXOjbect: function(){
        return document.applets.length > 0 || document.getElementsByTagName("Object").length > 0;
    },
    
    // temp fix for old widget spec
    oldWidgetSpecHitch: function(){ // for custom dialog instance to over write
    },
    // end temp fix
    
    registerSubDialog: function(subDialogId){
        if (dojo.isString(subDialogId)) {
            this.subDialogs.push(subDialogId);
            var subDialog = dijit.byId(subDialogId);
            if (subDialog && !subDialog.modelDialog) {
                subDialog.domNode.style.zIndex = this.domNode.style.zIndex;
            }
        }
    },
    
    hideWithKey: function(event){
        var keyCode = event.keyCode;
        if (keyCode != dojo.keys.ENTER) {
			return true;
		}
        this.hide();
    },
    
    hide: function(){		
        this.doHide();
    },
    
    doHide: function(){
		if (!this.open) {
			return;
		}
		
    	if (!dojo.isIE && this.closeButtonNode.style.display != "none") {
			this.closeButtonNode.focus();
		}
		
        //disconnect the onkey function for the dialog
        if (this.dialogStack.length > 1) {
            var subDig = this.dialogStack.pop();
            dojo.disconnect(subDig.onKeyHandler);
            var parentDialog = this.dialogStack[this.dialogStack.length - 1];
            parentDialog.onKeyHandler = dojo.connect(document.documentElement, "onkeypress", parentDialog, "_onKey");
        }
        else 
            if (this.dialogStack.length === 1) {
                var dialog = this.dialogStack.pop();
                dojo.disconnect(dialog.onKeyHandler);
            }
			
		dojo.forEach(this.subDialogs, function(subDialogId){
			var subDialog = dijit.byId(subDialogId);
			if(subDialog){
				subDialog.hide();
			}
		});

        // temp fix for old widget spec
        setTimeout(this.oldWidgetSpecHitch, this.duration);
    
		//override the dijit.Dialog hide logic here. 
		var ds = com.ibm.mm.builder.widget.customDialogStack;
		if(!this._alreadyInitialized || this != ds[ds.length-1]){
			return;
		}
		
		if(this.modelDialog){
			com.ibm.mm.builder.widget.customDlgHighestZIndex -= 2;
			this.domNode.style.zIndex = com.ibm.mm.builder.widget.customDlgZIndexOnPage;
		}
		
		if(this._fadeIn.status() == "playing"){
			this._fadeIn.stop();
		}
		
		com.ibm.mm.builder.widget.customDialogStack.pop();

		this._fadeOut.play();

		if (this._scrollConnected){
			this._scrollConnected = false;
		}
		dojo.forEach(this._modalconnects, dojo.disconnect);
		this._modalconnects = [];

		if(this._relativePosition){
			delete this._relativePosition;	
		}
		this.open = false;
	},
    
    trueHide: function(){
		this.doHide();
    },
    
	_onKey: function(/*Event*/ evt){
		// summary:
		//		Handles the keyboard events for accessibility reasons
		// tags:
		//		private
		// on dojo 1.6, the dijit._dialogStack ALWAYS contains a (non-dialog) element; plus the
		// elements in dojo 1.4 are Dialogs, where in dojo 1.6 they are javascript objects 
		// containing Dialogs, amongst other properties
		if (dijit._dialogStack && ((dijit._dialogStack.length > 1 && dijit._dialogStack[0].dialog === null) || (dijit._dialogStack.length > 0 && dijit._dialogStack[0] instanceof dijit.Dialog))) {
			return;
		}
			
		var ds = com.ibm.mm.builder.widget.customDialogStack;
		if (ds[ds.length - 1] != this) {
			return;
		}
		
		if (evt.charOrCode) {
			var dk = dojo.keys;
			var node = evt.target;
			if (evt.charOrCode === dk.TAB) {
				this._getFocusItems(this.domNode);
			}
			var singleFocusItem = (this._firstFocusItem == this._lastFocusItem);
			// see if we are shift-tabbing from first focusable item on dialog
			if (node == this._firstFocusItem && evt.shiftKey && evt.charOrCode === dk.TAB) {
				if (!singleFocusItem) {
					dijit.focus(this._lastFocusItem); // send focus to last item in dialog
				}
				dojo.stopEvent(evt);
			}
			else 
				if (node == this._lastFocusItem && evt.charOrCode === dk.TAB && !evt.shiftKey) {
					if (!singleFocusItem) {
						dijit.focus(this._firstFocusItem); // send focus to first item in dialog
					}
					dojo.stopEvent(evt);
				}
				else {
					// see if the key is for the dialog
					while (node) {
						if (node == this.domNode) {
							if (evt.charOrCode == dk.ESCAPE) {
								this.onCancel();
							}
							else {
								return; // just let it go
							}
						}
						node = node.parentNode;
					}
					// this key is for the disabled document window
					if (evt.charOrCode !== dk.TAB) { // allow tabbing into the dialog for a11y
						dojo.stopEvent(evt);
					// opera won't tab to a div
					}
					else 
						if (!dojo.isOpera) {
							try {
								this._firstFocusItem.focus();
							} 
							catch (e) { /*squelch*/
							}
						}
				}
		}
	},
	
	/**
	 * the recommended way to get underlay of the dialog.
	 */
    _getUnderlay: function(){
		if (!this._underlay) {
			this._underlay = new com.ibm.mm.builder.widget.CustomDialogUnderlay();
		}
		return this._underlay;		
	},
	
	//In dojo 1.4, we can use dojo.isMac
	_isMac : function() {
		return navigator.appVersion.indexOf("Macintosh") >= 0;
	},
	
	/**
	 * Initialization when the dialog is showed for the first time
	 */
    _setup: function(){
        this.moveableHandles = [];
        
		//initialize the global dijit._underlay to avoid exception when the parent's uninitialize is called
		if (!dijit._underlay) {
			dijit._underlay = new dijit.DialogUnderlay();
		} 
		
        if (this.titleBar) {
			this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
				handle: this.titleBar
			}));
		}
        if (this.leftBar) {
			this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
				handle: this.leftBar
			}));
		}
        if (this.rightBar) {
			this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
				handle: this.rightBar
			}));
		}
        if (this.endBar) {
			this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
				handle: this.endBar
			}));
		}
        
        if (this.modelDialog) { // is model dialog
//			com.ibm.mm.builder.widget.customDlgZIndexOnPage += 2;	//Increase every time when there is a new model dialog on the page
            this.domNode.style.zIndex = com.ibm.mm.builder.widget.customDlgZIndexOnPage;
        } else { 				// is not model dialog
        	//if (!this.isEmbedPageBidi) { 9637
        		com.ibm.mm.builder.utils.htmlUtil.setClass(this.domNode, "custom_dialog_nomodel");
        	//}
        }
		
		var node = this.domNode;
		if (this.modelDialog && this.needUnderLay) {
			var underlay = this._getUnderlay();
            this._fadeIn = dojo.fx.combine([
				dojo.fadeIn({
                    node: node,
                    duration: this.duration,
					onEnd: dojo.hitch(this,function(){
						if(this.dialogOpacity != null) {
							dojo.style(this.domNode, "opacity", this.dialogOpacity);
						}
					})
                }), 
				dojo.fadeIn({
                    node: underlay.domNode,
                    duration: this.duration,
                    onEnd: dojo.hitch(this, function(){
                        underlay.show();
                        underlay.setZIndex(dojo.style(node, "zIndex") - 1);
                        //TODO: from dojo1.4, this can be removed, dijit.dialogUnderlay will add iframe by default.
						if (!(this._isMac() && dojo.isSafari == 4)) {
							this._addBackIFrame(dojo.style(node, "zIndex") - 2);
						}				
						
                    })
            	})
			]);
            this._fadeOut = dojo.fx.combine([
				dojo.fadeOut({
                    node: node,
                    duration: 600
            	}), 
				dojo.fadeOut({
                    node: underlay.domNode,
                    duration: 700,
                    onEnd: dojo.hitch(this, function(){
						node.style.display = "none";
                        underlay.hide();
                        //TODO: from dojo1.4, this can be removed, dijit.dialogUnderlay will add iframe by default.
						this._removeBackIFrame();
						if (this.closeCallback) {
							setTimeout(dojo.hitch(this, this.closeCallback), 500);
						}
              		})
            	})
			]);
        } else {
            this._fadeIn = dojo.fadeIn({
                node: node,
                duration: this.duration,
				onEnd: dojo.hitch(this, function(){
					if(this.dialogOpacity != null) {
						dojo.style(this.domNode, "opacity", this.dialogOpacity);
					}
				})
            });
            this._fadeOut = dojo.fadeOut({
                node: node,
                duration: 600,
                onEnd: dojo.hitch(this,function(){
                    node.style.display = "none";
					if (this.closeCallback) {
						setTimeout(dojo.hitch(this, this.closeCallback), 500);
					}
                })
            });
        }
    },
	
	/**
	 * Initialize the skin of the dialog accoring to the given params when the it's created
	 */
	InitDialogSkin: function(){
        if (this.roundCorner) {
			dojo.addClass(this.dialogNode, "mumRoundCorner");
		}
        
        this.closeButtonNode.style.display = this.displayCloseButton ? "" : "none";
        
        if (!this.title) {
            this.titleNode.style.display = "none";
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.titleBar, "dialog_titlebar_notitle");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.leftBar, "dialog_leftsidebar_notitle");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.rightBar, "dialog_rightsidebar_notitle");
            this.titleHeight = 14;
        }
        else {
            this.titleNode.style.display = "";
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.titleBar, "dialog_titlebar");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.leftBar, "dialog_leftsidebar");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.rightBar, "dialog_rightsidebar");
            this.titleHeight = 28;
        }
        
        if (this.nodeWidth) {
			(this.containerNode.style.width = this.nodeWidth);
		}
		dojo.forEach((this.nodeStyle || "").split(";"), function(singleStyle){
			var kvp = singleStyle.split(":");
			if (kvp.length === 2) {
				this.containerNode.style[kvp[0]] = kvp[1];
			}
		}, this);
        if (this.nodeHeight) {
			this.containerNode.style.height = this.nodeHeight;
		}
		
        if (this.containerNodePadding){this.containerNode.style.padding = this.containerNodePadding;}
        if (this.leftBarWidth) {
			this.leftBar.style.width = this.leftBarWidth;
		}
        if (this.leftBarWidth) {
			this.containerNode.style.marginLeft = this.leftBarWidth;
		}
        if (this.rightBarWidth) {
			this.rightBar.style.width = this.rightBarWidth;
		}
        if (this.rightBarWidth) {
			this.containerNode.style.marginRight = this.rightBarWidth;
		}
        if (this.containerBackgroundColor) {
			this.containerNode.style.backgroundColor = this.containerBackgroundColor;
		}
        if (this.containerOpacity) {
			this.containerNode.style.opacity = this.containerOpacity;
		}
		
        //the style of the title and bottom bar
        if (this.topBarBackground) {
			this.titleBar.style.backgroundColor = this.topBarBackground;
		}
        if (this.topBarOpacity) {
			this.titleBar.style.opacity = this.topBarOpacity;
		}
        if (this.topBarOpacity) {
			this.titleBar.style.filter = "progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=" + this.topBarOpacity * 100;
		}
        if (this.titleBarHeight != "0px") {
			this.titleBar.style.height = this.titleBarHeight;
		}
        if (this.bottomBarBackground) {
			this.endBar.style.backgroundColor = this.bottomBarBackground;
		}
        if (this.bottomBarOpacity) {
			this.endBar.style.opacity = this.bottomBarOpacity;
		}
        if (this.bottomBarOpacity) {
			this.endBar.style.filter = "progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=" + this.bottomBarOpacity * 100;
		}
        
        if (this.endBarHeight && this.endBarHeight != "0px") {
            this.endBar.style.height = this.endBarHeight;
            var _height = parseInt(this.endBarHeight,10) + 1 + "px";
            this.leftBar.style.bottom = _height;
            this.rightBar.style.bottom = _height;
        }
        
        if (this.bottomBarTip) {
			this.endBar.innerHTML = this.bottomBarTip;
			this.endBar.style.color = this.bottomBarTipColor;
		}
        //Init resize handle
        if (this.hasLeftBottomResizer) {
			this.leftResizeHandler.style.display = "";
            this.leftResizer = new com.ibm.mm.builder.widget.CustomDialogResizer({
                targetContainer: this.domNode,
                animateSizing: false,
                activeResize: true,
                innerContainer: this.containerNode,
                innerMargin: {
                    top: this.titleHeight,
                    bottom: this.bottomHeight,
                    left: parseInt(this.leftBarWidth,10),
                    right: parseInt(this.rightBarWidth,10)
                },
				onResize: dojo.hitch(this, "onResize")
            }, this.leftResizeHandler);
            this.leftResizer.startup();
        }
        if (this.hasRightBottomResizer) {
			this.rightResizeHandler.style.display = "";
            this.rightResizer = new com.ibm.mm.builder.widget.CustomDialogResizer({
                targetContainer: this.domNode,
                animateSizing: false,
                activeResize: true,
                innerContainer: this.containerNode,
                innerMargin: {
                    top: this.titleHeight,
                    bottom: this.bottomHeight,
                    left: parseInt(this.leftBarWidth,10),
                    right: parseInt(this.rightBarWidth,10)
                },
				onResize: dojo.hitch(this, "onResize")
            }, this.rightResizeHandler);
            this.rightResizer.startup();
        }
    },
    
    /**
     * Display the dialog
     */
    show: function(){
        if (this.open) {
			return;
		}
        
		// first time we show the dialog, there's some initialization stuff to do			
        if (!this._alreadyInitialized) {
            this._setup();
			this.InitDialogSkin();
            this._alreadyInitialized = true;
        }
        if (this._fadeOut.status() == "playing") {
            this._fadeOut.stop();
        }
        
        this._modalconnects.push(dojo.connect(window, "onscroll", this, "layout"));
        this._modalconnects.push(dojo.connect(window, "onresize", this, function(){
				// IE gives spurious resize events and can actually get stuck
				// in an infinite loop if we don't ignore them
				var viewport = dijit.getViewport();
				if(!this._oldViewport ||
						viewport.h != this._oldViewport.h ||
						viewport.w != this._oldViewport.w){
					this.layout();
					this._oldViewport = viewport;
				}
			}));
		
        if (this.dialogStack.length > 0) {
            var formerDialog = this.dialogStack[this.dialogStack.length - 1];
            dojo.disconnect(formerDialog.onKeyHandler);
        }
        this.dialogStack.push(this);
        if (this.modelDialog) {
            this._modalconnects.push(this.onKeyHandler = dojo.connect(document.documentElement, "onkeypress", this, "_onKey"));
        }
        
        dojo.style(this.domNode, "opacity", 0);
        var hasHeightDivList = [];
        //fix the width bug of IE6 
        if (!this.dynaInitialized) {
            if (dojo.isIE == 6) {
                dojo.query("div", this.domNode).forEach(function(node, i){
                    // add if cause here ,if need.
                    var heightObj = [];
                    heightObj.node = node;
                    heightObj.height = node.style.height;
                    node.style.height = "auto";
                    hasHeightDivList.push(heightObj);
                });
            }
        }
        this.domNode.style.display = "block";
        this.domNode.style.visibility = "";
        this.open = true;
        //removed in dojo1.4
//        this._loadCheck(); // lazy load trigger
		
		//only do this once, when use modify the width/height of the dialog by resizer, the second time show will keep the user's config
        if (!this.dynaInitialized) {
        	this.domNode.style.height = null;
        	
        	if(this.nodeHeight !== null){
        		this.containerNode.style.height = this.nodeHeight;
        	}else {
        		this.containerNode.style.height = null;
        	}
        	
            var leftnum = parseInt(this.leftBarWidth.substring(0, this.leftBarWidth.length - 2),10);
            var rightnum = parseInt(this.rightBarWidth.substring(0, this.rightBarWidth.length - 2),10);
            var nodeWidthNum;
            if (this.nodeWidth !== null) {
				this.containerNode.style.width = this.nodeWidth;
                nodeWidthNum = parseInt(this.nodeWidth.substring(0, this.nodeWidth.length - 2),10);
                this.domNode.style.width = (nodeWidthNum + leftnum + rightnum + 2) + "px";
            }
            else {
				var node;
				if(this.containerNode.hasChildNodes())
				{
					node = this.containerNode.childNodes[0];
				}
				else
				{
					node = this.containerNode;
				}
				
                nodeWidthNum = dojo.coords(node).w;
                this.containerNode.style.width = nodeWidthNum + "px";
                // 20970
                // this.domNode.style.width = (nodeWidthNum + leftnum + rightnum + 2) + "px";
                this.domNode.style.width = "auto";
            }
            if (dojo.isIE == 6) {
                for (var i = 0; i < hasHeightDivList.length; i++) {
                    if (hasHeightDivList[i].height && hasHeightDivList[i].height != "auto") {
                        hasHeightDivList[i].node.style.height = hasHeightDivList[i].height;
                    }
                    else {
                        hasHeightDivList[i].node.style.height = "";
                    }
                }
            }
            this._position();
            this.positionWithGivenValue();
            
            if (document.body.dir=='rtl' && dojo.isSafari && navigator.userAgent.indexOf('iPad') != -1) {
                var node = dojo.byId(this.id+"_titleBar");
                if (node) {
                    var titleWidth = node.clientWidth+13;
                    dojo.style(node,{"width":titleWidth+"px"});
                    node = dojo.byId(this.id+"_closeIcon");
                    if (node) {
                        dojo.style(node,{"position":"relative","right":titleWidth-5+"px"});                    
                    }
                }
            }

			this.dynaInitialized = true;
        } else {
            if (this.alwaysCenter && this.initLeftPosition === null && this.initTopPosition === null) {
				this._position();
			}
			dojo.style(this.containerNode, "width", "100%");
        }
//		this.hasXObject = this.containXOjbect();
//		if (this.hasXObject) {
//            //hide all the applets, otherwise the applets will display beyond the background layer
//            this._hideXObjects();
//        }
		
		//update the ZIndex information
		if(this.modelDialog){
			com.ibm.mm.builder.widget.customDlgHighestZIndex += 2;
			this.domNode.style.zIndex = com.ibm.mm.builder.widget.customDlgHighestZIndex;
		}
		
         //set title after width has been set
        this.setTitle();
        com.ibm.mm.builder.widget.customDialogStack.push(this);
        this._fadeIn.play();
        this._savedFocus = dijit.getFocus(this);
        
        hasHeightDivList = null;
        //For dojo1.1.1 support
        this._getFocusItems(this.domNode);
        // set timeout to allow the browser to render dialog
        setTimeout(dojo.hitch(this, function(){
			try {
				var elems = dijit._getTabNavigable(this.containerNode);
				var f = elems.lowest || elems.first || this._firstFocusItem;
				if (f) {
					dijit.focus(f);
				}
				if(this.displayCallback){
					this.displayCallback();
				}
			} catch (e) {
				this.closeButtonNode.focus();
			}
        }), this.duration + 500);
    },
	
    setNodeWidth: function(newWidth){
        this.containerNode.style.width = this.nodeWidth = newWidth;
        if (this.dynaInitialized) { //if has been shown
            var leftnum = parseInt(this.leftBarWidth,10);
            var rightnum = parseInt(this.rightBarWidth,10);
            var nodeWidthNum = this.nodeWidth ? parseInt(this.nodeWidth,10) : dojo.coords(this.containerNode).w;
            
            this.domNode.style.width = (nodeWidthNum + leftnum + rightnum + 2) + "px";
        }
    },
    
    setNodeHeight: function(newHeight){
        this.containerNode.style.height = this.nodeHeight = newHeight;
    },
    
    setBottomTip: function(tip){
        this.endBar.innerHTML = this.bottomBarTip = tip;
    },
    
    setBottomTipColor: function(color){
        this.endBar.style.color = this.bottomBarTipColor = color;
    },
    
    autoAdjust: function(){},
    
    
    //Although this is a protected function for dijit.Dialog
    //Use it anyway to avoid copy much code from dijit.Dialog
	onCancel: function(){
		this.trueHide();
	},
    
    destroyOnPageChange: function(){
        if (!this.sharedWidget) {
			this.destroy();
		}
    },
    
    destroy: function(){
		this.open && this.hide();
		dojo.forEach(this.innerConnects, dojo.disconnect);
		if (this.moveableHandles){
			for (var i = 0; i < this.moveableHandles.length; i++){
				this.moveableHandles[i].destroy();
			}
		}
		
		dojo.destroy(this.leftBar);
		dojo.destroy(this.rightBar);
		dojo.destroy(this.endBar);
		dojo.destroy(this.closeButtonNode);
		dojo.destroy(this.titleBar);
		
		this.leftResizer && this.leftResizer.destroy();
		this.rightResizer && this.rightResizer.destroy();
		
		dojo.destroy(this.leftResizeHandler);
		dojo.destroy(this.rightResizeHandler);
		
		if (this._underlay) { // need this since from 1.3.2, dijit.dialog doesn't destroy the underlay
			this._underlay.destroy();
			this._underlay = null;
		}
		this.shimmer && dojo.destroy(this.shimmer);
		this.inherited(arguments);
    },
    
    positionWithGivenValue: function(){
        if (this.initLeftPosition) {
			this.domNode.style.left = this.initLeftPosition;
		}
        if (this.initTopPosition) {
			this.domNode.style.top = this.initTopPosition;
		}
    },
    
    /**
     * Position modal dialog in center of screen
     */
    _position: function(){
        if (dojo.hasClass(dojo.body(), "dojoMove")) {
			return;
		}
		// wait a moment until the domNode is fully ready, otherwise it's height maybe wrong
		window.setTimeout(dojo.hitch(this,function(){
			var viewport = dijit.getViewport();
	        var mb = dojo.marginBox(this.domNode);
	        
	        if (mb) { //fix defect 19481
		        var left = Math.floor((viewport.l + (viewport.w - mb.w) / 2));
		        var top = Math.floor((viewport.t + (viewport.h - mb.h) / 2));
		        this.domNode.style.left = left > 0 ? left + "px" : "0px";
		        this.domNode.style.top = top > 0 ? top + "px" : "0px";
	        } else {
		        this._position();
		    }
		}),100);
    },
    
    layout: function(){
        // summary: position the Dialog and the underlay
        if (this.domNode.style.display != "none" && this.modelDialog && this.needUnderLay) {
            this._getUnderlay().layout();
        }
    },
    
    /**
     * This function will add one iframe under the underlay of the dialog
     * Its purpose is to solve the overlap problem of applet,flash,ActiveX object,ect.
     */
    _addBackIFrame: function(zIndex){
		this.shimmer = document.createElement('iframe');
		this.shimmer.style.position = 'absolute';
		this.shimmer.style.zIndex = zIndex;
		this.shimmer.setAttribute('frameborder', '0');
		this.shimmer.style.filter = 'progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0)';
		document.body.appendChild(this.shimmer);
        this._adjustBackIFramePosition();
    },
    
    /**
     * This function is in charge of adjust the iframe's positon when user scroll the window
     */
    _adjustBackIFramePosition: function(){
        var viewport = dijit.getViewport();
        this.shimmer.style.top = viewport.t + "px";
        this.shimmer.style.left = viewport.l + "px";
        this.shimmer.style.width = viewport.w + "px";
        this.shimmer.style.height = viewport.h + "px";
        
        // process twice since the scroll bar may have been removed
        // by the previous resizing
        var viewport2 = dijit.getViewport();
        if (viewport.w != viewport2.w) {
            this.shimmer.style.width = viewport2.w + "px";
        }
        if (viewport.h != viewport2.h) {
            this.shimmer.style.height = viewport2.h + "px";
        }
    },
    
    /**
     * Remove the iframe when the dialog is hidden
     */
    _removeBackIFrame: function(){
        if (this.shimmer) {
			dojo.destroy(this.shimmer);
			this.shimmer = null;
        }
    },
    
//    _hideXObjects: function(){
//        //hide all the applets
//        var applets = document.getElementsByTagName("Applet");
//        for (var i = 0; i < applets.length; i++) {
//            applets[i].style.visibility = "hidden";
//        }
//        //hide all object div(flash, svg)
//        var objs = document.getElementsByTagName("Object");
//        for (var i = 0; i < objs.length; i++) {
//            objs[i].style.visibility = "hidden";
//        }
//    },
	
	onResize: function(width, height){
		// hook for child widgets
	}
});

com.ibm.mm.builder.widget.customDialogStack = [];
com.ibm.mm.builder.widget.customDlgZIndexOnPage = 800;
com.ibm.mm.builder.widget.customDlgHighestZIndex = 800;
com.ibm.mm.builder.widget.editDialogUnderlay = null;

dojo.declare("com.ibm.mm.builder.widget.CleanDialog", com.ibm.mm.builder.widget.CustomDialog, {
	/**
	 * Override the super method to make all WidgetEditDialog use the only global underlay:
	 * com.ibm.mm.builder.widget.editDialogUnderlay
	 */
	_getUnderlay: function(){
		if (!com.ibm.mm.builder.widget.editDialogUnderlay) {
			com.ibm.mm.builder.widget.editDialogUnderlay = new com.ibm.mm.builder.widget.CustomDialogUnderlay({
				id: "cleanDialogUnderlay"
			});
		}
		return com.ibm.mm.builder.widget.editDialogUnderlay;
	}
});

dojo.declare("com.ibm.mm.builder.widget.GeneralWidgetModeDialog", com.ibm.mm.builder.widget.CleanDialog, {
	
	postCreate: function(){
		this.inherited(arguments);
		this.modeChangeHandle = dojo.subscribe(iwConstants.EVENTS.modeChanged,
			this, this.onModeChanged);
	},
	
	onModeChanged: function(widgetId, mode){
		this.hide();
	},
	
	hideWithKey: function(event){
        var keyCode = event.keyCode;
        if (keyCode != dojo.keys.ENTER) {
			return true;
		}
        this.trueHide();
    },
	
	trueHide: function(){
		if(this.belongId) {
			com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this.belongId, "onModeChanged", {newMode:'view'});
			return;	
		}
		this.doHide();
	},
	
	destroy: function(){
		dojo.unsubscribe(this.modeChangeHandle);
		this.inherited(arguments);
	}
});

dojo.declare("com.ibm.mm.builder.widget.WidgetEditDialog", com.ibm.mm.builder.widget.GeneralWidgetModeDialog, {
	onModeChanged: function(widgetId, mode){
		if(mode === "edit" && this.belongId === widgetId) {
			this.hide();
		}
	}
});

dojo.declare("com.ibm.mm.builder.widget.CustomDialogUnderlay", dijit.DialogUnderlay, {
    templateString: 
		'<div class="customDialogUnderlayWrapper" id="${id}_underlay">' +
    		'<div class="customDialogUnderlay" dojoAttachPoint="node"></div>' +
    	'</div>',
    
    setZIndex: function(zIndex){
        dojo.style(this.domNode, "zIndex", zIndex);
    }
//	postCreate: function() {
//		this.inherited('postCreate',arguments);
//		if(this.bgIframe.iframe){
//			dojo.attr(this.bgIframe.iframe,'title','underlay');
//		}
//	}

});

}
